package org.aaron.camel.test;

import org.apache.camel.EndpointInject;
import org.apache.camel.ProducerTemplate;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class Requestor {

	private final Log log = LogFactory.getLog(getClass());

	@EndpointInject(ref = "requestQueue")
	private ProducerTemplate requestQueue = null;

	@EndpointInject(ref = "testTopic")
	private ProducerTemplate testTopic = null;

	public void init() {
		new Thread(new Runnable() {
			@Override
			public void run() {
				makeRequest();
			}
		}).start();

		new Thread(new Runnable() {
			@Override
			public void run() {
				publishToTestTopic();
			}
		}).start();
	}

	public void destroy() {

	}

	private void makeRequest() {
		int i = 0;
		while (true) {
			try {
				Thread.sleep(1000);
				log.info("makeRequest " + i);
				final Object response = requestQueue
						.requestBody("request " + i);
				log.info("response = '" + response + "'");
			} catch (Exception e) {
				log.warn("makeRequest", e);
			}
			++i;
		}
	}

	private void publishToTestTopic() {
		while (true) {
			try {
				Thread.sleep(1000);
				log.info("publishToTestTopic");
				testTopic.sendBody("test");
			} catch (Exception e) {
				log.warn("makeRequest", e);
			}
		}
	}
}
